LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


ENTITY clockDivider IS PORT( 
      clk        : IN     std_logic;
	  clockMultiplier: IN std_logic_vector (1 downto 0);
      clkClock   : BUFFER std_logic;
      clkDisplay : BUFFER std_logic);
END clockDivider ;


ARCHITECTURE main OF clockDivider IS
   signal clockCount: integer RANGE 0 TO 10875599;
   
BEGIN
   clkDisplay <= clk;
   
   clockCounter: process(clk)
	  variable shouldTick: boolean;

   begin
      if (clk'event and clk = '1') then
		 case clockMultiplier is
			when "11" => shouldTick := (clockCount = 10875599);
			when "10" => shouldTick := (clockCount = 1087559);
			when "01" => shouldTick := (clockCount = 108755);
			when "00" => shouldTick := (clockCount = 10875);
			when others => shouldTick := false;
		 end case;

         if (shouldTick = true) then
            clkClock <= not clkClock;
            clockCount <= 0;
         else
            clockCount <= clockCount + 1;
         end if;
      end if;
   end process;
END main;
