LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


ENTITY displayDriver IS PORT( 
      clkDisplay : IN     std_logic;
      hours      : IN     std_logic_vector (3 DOWNTO 0);
      minutes    : IN     std_logic_vector (7 DOWNTO 0);
      seconds    : IN     std_logic_vector (7 DOWNTO 0);
	  show		 : IN	  std_logic_vector (2 DOWNTO 0);
      enable     : OUT    std_logic_vector (5 DOWNTO 0);
      segDisplay : OUT    std_logic_vector (7 DOWNTO 0);
      strobe     : OUT    std_logic_vector (5 DOWNTO 0));
END displayDriver ;


ARCHITECTURE struct OF displayDriver IS
   -- Internal signal declarations
   SIGNAL value : std_logic_vector(3 DOWNTO 0);

   -- Component Declarations
   COMPONENT segDecoder PORT (
      value      : IN     std_logic_vector (3 DOWNTO 0);
      segDisplay : OUT    std_logic_vector (7 DOWNTO 0));
   END COMPONENT;
   COMPONENT segMultiplexer PORT (
      clkDisplay : IN     std_logic ;
      hours      : IN     std_logic_vector (3 DOWNTO 0);
      minutes    : IN     std_logic_vector (7 DOWNTO 0);
      seconds    : IN     std_logic_vector (7 DOWNTO 0);
	  show		 : IN	  std_logic_vector (2 DOWNTO 0);
      enable     : OUT    std_logic_vector (5 DOWNTO 0);
      strobe     : OUT    std_logic_vector (5 DOWNTO 0);
      value      : OUT    std_logic_vector (3 DOWNTO 0));
   END COMPONENT;

BEGIN
   -- Instance port mappings.
   I1 : segDecoder PORT MAP (
         value      => value,
         segDisplay => segDisplay);
   I0 : segMultiplexer PORT MAP (
         clkDisplay => clkDisplay,
         hours      => hours,
         minutes    => minutes,
         seconds    => seconds,
		 show		=> show,
         enable     => enable,
         strobe     => strobe,
         value      => value);
END struct;
