LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


ENTITY segMultiplexer IS PORT( 
      clkDisplay : IN     std_logic;
      hours      : IN     std_logic_vector (3 DOWNTO 0);
      minutes    : IN     std_logic_vector (7 DOWNTO 0);
      seconds    : IN     std_logic_vector (7 DOWNTO 0);
	  show		 : IN	  std_logic_vector (2 DOWNTO 0);
      enable     : OUT    std_logic_vector (5 DOWNTO 0);
      strobe     : OUT    std_logic_vector (5 DOWNTO 0);
      value      : OUT    std_logic_vector (3 DOWNTO 0));
END segMultiplexer ;


ARCHITECTURE main OF segMultiplexer IS
   signal state: integer RANGE 0 to 11;
BEGIN
   enable(0) <= show(0);
   enable(1) <= show(0);
   enable(2) <= show(1);
   enable(3) <= show(1);
   enable(4) <= show(2);
   enable(5) <= show(2);

   stateMachine: process(clkDisplay)
   begin
      if (clkDisplay'event and clkDisplay = '1') then
         strobe <= "000000";
         
         if (state = 11) then
            state <= 0;
         else 
            state <= state + 1;
         end if;
         
         case state is
               when 0 => if (hours = "0000") then
                            value <= "0001";
                         else
                            value <= "0000";
                         end if;
			   when 1 => if (hours = "0000") then
                            value <= "0001";
                         else
                            value <= "0000";
                         end if;

               when 2 => value <= hours(3 downto 0);
               when 3 => value <= hours(3 downto 0);
               when 4 => value <= minutes(7 downto 4);
               when 5 => value <= minutes(7 downto 4);
               when 6 => value <= minutes(3 downto 0);
               when 7 => value <= minutes(3 downto 0);
               when 8 => value <= seconds(7 downto 4);
               when 9 => value <= seconds(7 downto 4);
               when 10 => value <= seconds(3 downto 0);
               when 11 => value <= seconds(3 downto 0);
               when others => value <= "0000";
         end case;

		 case state is
			   when 1 => strobe(5) <= '1';
			   when 3 => strobe(4) <= '1';
			   when 5 => strobe(3) <= '1';
			   when 7 => strobe(2) <= '1';
			   when 9 => strobe(1) <= '1';
			   when 11 => strobe(0) <= '1';
			   when others => strobe <= "000000";
		 end case;
      end if;
   end process;
END main;
